<template>
  <div data-view="settings">
    <layout-logged-frame :has-aside="false">
      <template slot="content">
        <div class="form-wrapper large">
          <h1>
            {{ 'Settings' }}
          </h1>
          <Can
            I="manage-notifications"
            a="user"
          >
            <layout-section-header
              title="Manage notifications"
              subtitle="You can create email notifications based on your own criteria. As soon as a new deal is submitted you will get notified."
              :trigger-label="!canEditNotifications ? 'Edit notifications' : 'Close'"
              @toggle="toggleEdit"
            />

            <UserNotifications
              :user="user"
              :is-disabled="!canEditNotifications"
            />
          </Can>

          <Can
            I="accept-business-contact-join"
            a="user"
          >
            <layout-section-header
              title="General"
              :subtitle="`You may let users to send you requests to create an account with an email address like ${domain}.`"
              :trigger-label="!canEditGeneral ? 'Edit general' : 'Close'"
              @toggle="toggleEditGeneral"
            />

            <UserSettingsForm
              v-if="settings.length > 0"
              :settings="settings"
              :is-disabled="!canEditGeneral"
              :is-loading="isLoading"
              :on-submit="onUpdateSettings"
            />
          </Can>
        </div>
      </template>
    </layout-logged-frame>
  </div>
</template>

<script>
  import UserNotifications from '../../components/forms/user/Notifications';
  import UserSettingsForm from '../../components/forms/user/Settings';
  import { eachProp, hasProp } from '../../utils';

  const settingLabels = {
    enable_register: 'Allow to sign up with company\'s domain'
  };

  // TODO: Translate view

  export default {
    components: {
      UserNotifications,
      UserSettingsForm
    },
    data() {
      return {
        settings: {},
        canEditNotifications: false,
        canEditGeneral: false,
        isLoading: false
      };
    },
    computed: {
      user() {
        return this.$store.getters['auth/user'];
      },
      domain() {
        const { email } = this.user;

        return email.match(/@.+/)[0];
      }
    },
    created() {
      if (this.$ability.can('accept-business-contact-join', 'user')) {
        this.getSettings();
      }
    },
    methods: {
      toggleEdit() {
        this.canEditNotifications = !this.canEditNotifications;
      },
      getSettings() {
        this.isLoading = true;

        return this.$store.dispatch('businessUsers/getSettings')
          .then((settings) => {
            this.settings = this.unwrapSettings(settings);
            this.isLoading = false;

            return settings;
          })
          .catch((err) => {
            this.isLoading = false;
            return err;
          });
      },
      onUpdateSettings() {
        const convertedSettings = this.wrapSettings(this.settings);

        const query = {
          settings: convertedSettings
        };

        this.isLoading = true;
        return this.$store.dispatch('businessUsers/updateSettings', query)
          .then((settings) => {
            this.settings = this.unwrapSettings(settings);
            this.isLoading = false;

            return settings;
          })
          .catch((err) => {
            this.isLoading = false;
            return err;
          });
      },
      unwrapSettings(settings) {
        const nextSettings = [];

        eachProp(settings, (isOn, key) => {
          nextSettings.push({
            label: this.getSettingLabel(key),
            key,
            isOn: isOn > 0
          });
        });

        return nextSettings;
      },
      wrapSettings() {
        const nextSettings = {};

        this.settings.forEach(({ isOn, key }) => {
          nextSettings[key] = isOn ? 1 : 0;
        });

        return nextSettings;
      },
      getSettingLabel(settingKey) {
        return hasProp(settingLabels, settingKey)
          ? settingLabels[settingKey]
          : settingKey;
      },
      toggleEditGeneral() {
        this.canEditGeneral = !this.canEditGeneral;
      }
    },
    metaInfo() {
      return {
        title: 'Settings'
      };
    }
  };
</script>

<style lang="stylus">
  [data-view="settings"] {
    [data-component="notifications"] {
      .v-input {
        padding-right: 8px;
      }
    }
  }
</style>
